<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Settings extends Controller_Handler {
       
        public function before() {
            $this->model = new Model_Account;
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();   
        }

        public function action_changeLogin()
        {
            $config = Kohana::$config->load('security.securityPolicy');
            $success = true;
            $this->post->rule('login', $config['login']['allowedSymbols'])->rule('login', 'not_empty');
            if($success = $this->post->check())
            {
                if($this->model->isAccountExists($this->post->offsetGet('login'), '1'))
                {
                    $success = false;
                    $this->post->error('login', 'already_exists');
                }
            }
            $user = Auth::getData();
            $arr['success'] = $success;
            if($arr['success'])
                $this->model->changeLogin($user['ID'], $this->post->offsetGet('login'));
            else
                $arr['errors'] = $this->post->errors ();
            $this->response->body(json_encode($arr));
        }
        
        public function action_changePassword()
        {
            $config = Kohana::$config->load('security.securityPolicy');
            $this->post
                ->rule('password', 'min_length', array(':value', $config['password']['length']))
                ->rule('confirm_password', 'matches', array(':validation', 'confirm_password', 'password'));
            $user = Auth::getData();
            $data = $this->model->getAccountInfoByID($user['ID'])->offsetGet(0);
            if($success = $this->post->check())
            {
                $password = sha1($this->post->offsetGet('old_password'));
                if($this->model->getAccountInfoByLogin($data['Login'], $password)->count() == 0)
                {
                    $this->post->error('old_password', 'invalid_password');
                    $success = false;
                }
                else
                {
                    $this->model->changePassword($user['ID'], sha1($this->post->offsetGet('password')));
                }
            }
            $arr['errors'] = $this->post->errors();
            $arr['success'] = $success;
            $this->response->body(json_encode($arr));            
        }
        
        public function action_changeEMail()
        {
                        
        }
        
        public function action_confirmNewEMail()
        {
            
        }
}